SystemOrganization addCategory: #'DBXTools-Descriptions'!

MAContainer subclass: #DBXApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXApplication methodsFor: 'visiting' stamp: 'GuillermoPolito 10/6/2011 04:15'!
acceptMagritte: aVisitor
	aVisitor visitApplication: self.
	self do: [ :entity | entity acceptMagritte: aVisitor ]! !

MAContainer subclass: #DBXEntity
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/6/2011 04:36'!
addAttribute: anAttribute
	 attributes add: anAttribute! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/6/2011 04:35'!
attributes
	^attributes! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/6/2011 04:35'!
attributesDo: anAction
	self attributes do: anAction! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/4/2011 15:17'!
category
	^ self propertyAt: #category! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/4/2011 15:17'!
category: aCategory
	^ self propertyAt: #category put: aCategory! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/4/2011 15:07'!
dbxClassName
	^ self propertyAt: #className ifAbsent: [ self defaultName ]! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/4/2011 15:08'!
dbxClassName: aClassName
	^ self propertyAt: #className put: aClassName! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/4/2011 15:08'!
defaultName
	^ self propertyAt: #defaultName! !

!DBXEntity methodsFor: 'accessing' stamp: 'GuillermoPolito 10/4/2011 15:08'!
defaultName: aName
	^ self propertyAt: #defaultName put: aName! !

!DBXEntity methodsFor: 'initialize-release' stamp: 'GuillermoPolito 10/6/2011 04:36'!
initialize 
	attributes := Set new! !

!DBXMySQLBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GuillermoPolito 9/27/2011 14:24'!
int
	^'int'! !

!MAElementDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 10/6/2011 03:20'!
name
	^self propertyAt: #name! !

!MAElementDescription methodsFor: '*dbxtools-descriptions' stamp: 'GuillermoPolito 10/6/2011 02:59'!
name: aName 
	self propertyAt: #name put: aName! !

!DBXBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GiselaDecuzzi 5/30/2011 02:51'!
allTableNamesQuery
	"SQL to obtain all the table name from the database. This is the ANSI SQL, if the database does not support this should be overwrited"
	^'SELECT * FROM INFORMATION_SCHEMA.TABLES'
	! !

!DBXBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GuillermoPolito 9/28/2011 02:07'!
columnLengthForRow: aDBXRow
	^aDBXRow rawValueNamed: 'length'! !

!DBXBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GuillermoPolito 9/27/2011 15:14'!
columnNullableColumnName
	^'is_nullable'! !

!DBXBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GiselaDecuzzi 9/26/2011 20:54'!
foreignKeysFor: tableName on: connection
	|rs fks|
	rs := self executeStatement: (self foreignKeysQuery:  tableName) on: connection.
	fks := Set new.
	rs rowsDo: [:aRow | fks add: (DBXForeignKey new name: (aRow rawValueNamed: 'name');
					foreignTable: (aRow rawValueNamed:  'foreign_table_name' );
					foreignColumn:(aRow rawValueNamed: 'foreign_column_name');
					table: tableName;
					column: (aRow rawValueNamed: 'column_name'); yourself )
				].	
	rs releaseResult .
	^ fks.! !

!DBXBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GiselaDecuzzi 9/26/2011 20:53'!
foreignKeysQuery: tableName
	"SQL to obtain all the foreign keys from the given tableName database. This is the ANSI SQL, if the database does not support this should be overwrited"
	^ 'SELECT tc.constraint_name AS name, 
			kcu.column_name AS column_name, 
			ccu.table_name AS foreign_table_name, 
			ccu.column_name AS foreign_column_name 
	FROM information_schema.table_constraints AS tc JOIN information_schema.key_column_usage AS kcu ON tc.constraint_name = kcu.constraint_name JOIN information_schema.constraint_column_usage AS ccu ON ccu.constraint_name = tc.constraint_name WHERE constraint_type = ''','FOREIGN KEY',''' AND tc.table_name=''' , tableName, '''' .
	! !

!DBXBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GuillermoPolito 9/27/2011 14:24'!
int
	^'integer'! !

!DBXBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GuillermoPolito 9/27/2011 15:17'!
stringToBool: aBooleanString
	^aBooleanString ~= 'NO'! !

!DBXBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GuillermoPolito 9/28/2011 02:08'!
tableDescription: tableName on: connection
	"returns the description for the tableName "
	| tableDescription rs |
	tableDescription := DBXMetaTable new name: tableName;yourself .
	rs := self executeStatement: (self tableDescriptionQuery: tableName) on: connection.
	rs rowsDo: [:aRow | 
			tableDescription 
				add: (aRow rawValueNamed: 'name')  
				of: (aRow rawValueNamed: 'type') 
				with: (self columnLengthForRow: aRow)
				nullable: (self stringToBool: (aRow rawValueNamed: self columnNullableColumnName ))].
	rs releaseResult.
	^tableDescription.! !

!DBXBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GiselaDecuzzi 5/31/2011 00:55'!
tableDescriptionQuery: tableName
	"SQL to obtain the table description from the database. This is the ANSI SQL, if the database does not support this should be overwrited"
	^'SELECT column_name as name, is_nullable, data_type as type, character_maximum_length as lenght FROM information_schema.COLUMNS WHERE table_name=''' , tableName, '''' .
	! !

!DBXBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GiselaDecuzzi 5/31/2011 01:44'!
tablesDescription: connection
	"Returns a collection  with all the database tables descripted"
	|rs tablesNames|
	rs := self executeStatement: self allTableNamesQuery on: connection.  
	tablesNames := rs rows inject: Set new into:  [:allTables :aRow | allTables add:  (aRow rawValueNamed: 'table_name'). allTables ].
	rs releaseResult .
	^tablesNames inject: Set new into:  [:allTables :tableName | allTables add: (self tableDescription: tableName on: connection ). allTables ].! !

!DBXSqliteBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GuillermoPolito 9/27/2011 15:05'!
allTableNamesQuery
	"SQL to obtain all the table name from the database. This is the ANSI SQL, if the database does not support this should be overwrited"
	^'SELECT name as table_name FROM sqlite_master
		WHERE type=''table''
		ORDER BY name;'
	! !

!DBXSqliteBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GuillermoPolito 9/28/2011 02:08'!
columnLengthForRow: aDBXRow
	^nil! !

!DBXSqliteBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GuillermoPolito 9/27/2011 15:15'!
columnNullableColumnName
	^'notnull'! !

!DBXSqliteBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GuillermoPolito 9/27/2011 15:17'!
stringToBool: aBooleanString
	^aBooleanString ~= '0'! !

!DBXSqliteBackend methodsFor: '*DBXTools-Descriptions' stamp: 'GuillermoPolito 9/27/2011 15:10'!
tableDescriptionQuery: aTableName
	^'Pragma table_info(' , aTableName, ')'! !

Object subclass: #DBXForeignKey
	instanceVariableNames: 'foreignTableName foreignColumnName tableName columnName name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GiselaDecuzzi 9/26/2011 20:44'!
column: theColumnName 
	columnName := theColumnName ! !

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GiselaDecuzzi 9/26/2011 20:43'!
foreignColumn: columnName 
	foreignColumnName := columnName .! !

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GiselaDecuzzi 9/26/2011 20:42'!
foreignTable: tableName 
	foreignTableName := tableName .! !

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GiselaDecuzzi 9/26/2011 20:50'!
name: fkName 
	name := fkName ! !

!DBXForeignKey methodsFor: 'as yet unclassified' stamp: 'GiselaDecuzzi 9/26/2011 20:44'!
table: theTableName 
	tableName := theTableName ! !

Object subclass: #DBXMagritteClassBuilderVisitor
	instanceVariableNames: 'mustBuildAccessors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXMagritteClassBuilderVisitor methodsFor: 'building' stamp: 'GuillermoPolito 10/6/2011 04:09'!
buildAccessorForAttribute: attribute inClass: aClass
	"getter"
	aClass compile: ('{1}
		^{1}' format: {attribute name}).
	"setter"
	aClass compile: ('{1}: {2}
		{1} := {2}' format: {attribute name .  (attribute name first isVowel ifTrue: ['an'] ifFalse: ['a']), attribute name capitalized })! !

!DBXMagritteClassBuilderVisitor methodsFor: 'building' stamp: 'GuillermoPolito 10/6/2011 04:56'!
buildAccessorsFor: aDBXEntity
	aDBXEntity attributesDo: [ :attribute |
			self buildAccessorForAttribute: attribute inClass: (Smalltalk globals at: aDBXEntity dbxClassName asSymbol)
		]! !

!DBXMagritteClassBuilderVisitor methodsFor: 'building' stamp: 'GuillermoPolito 10/6/2011 04:37'!
buildInstVarStringFromEntity: aDBXEntity
	^' ' join: (aDBXEntity attributes collect: #name)! !

!DBXMagritteClassBuilderVisitor methodsFor: 'initialize-release' stamp: 'GuillermoPolito 10/6/2011 04:10'!
initialize
	mustBuildAccessors := false! !

!DBXMagritteClassBuilderVisitor methodsFor: 'configuring' stamp: 'GuillermoPolito 10/6/2011 04:03'!
mustBuildAccessors: aBoolean
	mustBuildAccessors := aBoolean! !

!DBXMagritteClassBuilderVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 10/6/2011 03:18'!
visit: aDBXEntity 
	aDBXEntity acceptMagritte: self! !

!DBXMagritteClassBuilderVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 10/6/2011 04:09'!
visitContainer: aDBXEntity 

	| instVarString |
	instVarString := self buildInstVarStringFromEntity: aDBXEntity.
	Object subclass: aDBXEntity dbxClassName asSymbol
		instanceVariableNames: instVarString
		classVariableNames: ''
		poolDictionaries: ''
		category: aDBXEntity category.
	
	mustBuildAccessors ifTrue: [ self buildAccessorsFor: aDBXEntity ]
		! !

Object subclass: #DBXMagritteWriterVisitor
	instanceVariableNames: 'visitedEntity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXMagritteWriterVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 10/6/2011 04:34'!
visit: aDBXEntity 
	visitedEntity := aDBXEntity.
	aDBXEntity attributesDo: [ :attribute | attribute acceptMagritte: self ]
	! !

!DBXMagritteWriterVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 10/6/2011 05:00'!
visitNumberDescription: aMANumberDescription 
	self writeDescription: aMANumberDescription onClass: (self class environment at: visitedEntity dbxClassName asSymbol) class! !

!DBXMagritteWriterVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 10/6/2011 04:34'!
visitPriorityContainer: aMAPriorityContainer
	"Nothing"! !

!DBXMagritteWriterVisitor methodsFor: 'visiting' stamp: 'GuillermoPolito 10/6/2011 05:00'!
visitStringDescription: aMAStringDescription 
	self writeDescription: aMAStringDescription onClass: (self class environment at: visitedEntity dbxClassName asSymbol) class! !

!DBXMagritteWriterVisitor methodsFor: 'writing' stamp: 'GuillermoPolito 10/6/2011 05:05'!
writeDescription: aMADescription onClass: aClass
	| properties descriptionMethod |
	properties := ';
		' join: (aMADescription 
		properties 
		associations 
		collect: [ :assoc | '{1}: {2}' format: {assoc key . assoc value printString}]).
	
	descriptionMethod := 'description{1}
	^{2} new
		{3}
		yourself. ' 
		format: { aMADescription name capitalized. 
			aMADescription class name.
			properties }.
	aClass compile: descriptionMethod.! !

Object subclass: #DBXMetaAttribute
	instanceVariableNames: 'name nullable type length'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXMetaAttribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/19/2011 00:26'!
constraintsForCreate
	^(self nullable ifTrue:['']  ifFalse:[ ' NOT NULL ']).! !

!DBXMetaAttribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/18/2011 23:36'!
generateCreateTable

	^   self name, '  ', self typeForCreate, '  ', self constraintsForCreate. ! !

!DBXMetaAttribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/20/2011 17:49'!
length
	^ length! !

!DBXMetaAttribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/20/2011 17:51'!
length: anInteger
	length := anInteger ! !

!DBXMetaAttribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/20/2011 17:49'!
name
	^ name! !

!DBXMetaAttribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/20/2011 17:51'!
name: aString
	name := aString ! !

!DBXMetaAttribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/20/2011 17:49'!
nullable
	^ nullable! !

!DBXMetaAttribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/20/2011 17:51'!
nullable: aBoolean
	nullable := aBoolean ! !

!DBXMetaAttribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/20/2011 17:49'!
type
	^ type! !

!DBXMetaAttribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/20/2011 17:53'!
type: aString
" type recives a database type name. such as varchar char int etc"
	type := aString ! !

!DBXMetaAttribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/19/2011 02:06'!
typeForCreate
" 
  when len > 0 
    type (len)
 else
   type

"
	| lenStr | 
	
	lenStr:= self length ifNil:['']  
						ifNotNil:[ '(', self length asString , ')'] .
		
	^	self type, ' ',  lenStr 
		! !

Object subclass: #DBXMetaTable
	instanceVariableNames: 'attributes name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTools-Descriptions'!

!DBXMetaTable methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/20/2011 17:44'!
add:anAttributeName of:aType with:aLen
	| attribute |
	attribute := DBXMetaAttribute new.
	attribute name:anAttributeName ; type:aType;length: aLen .    
	attributes add: attribute.
	! !

!DBXMetaTable methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 9/27/2011 16:52'!
add:anAttributeName of:aType with:aLen nullable:aBool
	| attribute |
	attribute := DBXMetaAttribute new.
	attribute 
		name: anAttributeName; 
		type: aType;
		length: aLen;
		nullable: aBool.    
	attributes add: attribute.
	! !

!DBXMetaTable methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/20/2011 17:41'!
addAttribute:anAttribute
	attributes add:anAttribute .! !

!DBXMetaTable methodsFor: 'accessing' stamp: 'GiselaDecuzzi 5/30/2011 03:24'!
attributes
	^ attributes! !

!DBXMetaTable methodsFor: 'as yet unclassified' stamp: 'santiagobragagnolo 5/20/2011 17:38'!
attributesDo:aBlock
	attributes do:aBlock.! !

!DBXMetaTable methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/19/2011 03:12'!
generateCreateTable
	| sql  parenthesis |
	  sql := (attributes inject:'CREATE TABLE ', self name, ' ('  into:[:createTable :attribute | createTable, ' ', attribute generateCreateTable, ',' ]).
	
	parenthesis :=  ')' at:1. "fukn ugly"
	
	 sql at:(sql size) put: parenthesis. "Erase comma, add closer parenthesis"	
	^ sql, ';'.

	
! !

!DBXMetaTable methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/19/2011 03:12'!
generateDropTable
	^  ' DROP TABLE ', self name,  ';'.! !

!DBXMetaTable methodsFor: 'as yet unclassified' stamp: 'santiagobragagnolo 5/28/2011 16:24'!
initialize 
	attributes := OrderedCollection new.! !

!DBXMetaTable methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/20/2011 17:41'!
name
	^name! !

!DBXMetaTable methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/20/2011 17:41'!
name:aName
	name := aName .! !
